﻿#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

int lunarSum(int a, int b) {
    string strA = to_string(a);
    string strB = to_string(b);
    string result = "";

    int len = max(strA.length(), strB.length());

    for (int i = 0; i < len; ++i) {
        int digitA = (i < strA.length()) ? strA[strA.length() - 1 - i] - '0' : 0;
        int digitB = (i < strB.length()) ? strB[strB.length() - 1 - i] - '0' : 0;
        result += to_string(max(digitA, digitB));
    }

    reverse(result.begin(), result.end());
    return stoi(result);
}

int lunarProd(int a, int b) {
    string strA = to_string(a);
    string strB = to_string(b);
    string result = "";

    for (char digitA : strA) {
        for (char digitB : strB) {
            result += to_string(min(digitA - '0', digitB - '0'));
        }
    }

    return stoi(result);
}

int main() {
    long long a, b;
    cin >> a >> b;

    cout << lunarSum(a, b) << " " << lunarProd(a, b) << endl;

    return 0;
}
