﻿#include <iostream>
#include <string>
#include <algorithm>

using namespace std;

string lunarSum(const string& a, const string& b) {
    string result = "";
    int maxLength = max(a.length(), b.length());

    for (int i = 0; i < maxLength; ++i) {
        int digitA = (i < a.length()) ? a[a.length() - 1 - i] - '0' : 0;
        int digitB = (i < b.length()) ? b[b.length() - 1 - i] - '0' : 0;
        result += to_string(max(digitA, digitB));
    }

    reverse(result.begin(), result.end());
    return result;
}

string lunarProd(const string& a, const string& b) {
    string result = "";

    for (char digitA : a) {
        for (char digitB : b) {
            result += to_string(min(digitA - '0', digitB - '0'));
        }
    }

    return result;
}

int main() {
    string a, b;
    cin >> a >> b;

    string sum = lunarSum(a, b);
    string prod = lunarProd(a, b);

    cout << sum << " " << prod << endl;

    return 0;
}
