﻿#include <iostream>
#include <string>

using namespace std;

string findPath(int a, int b) {
    string path = "";
    int left_numerator = 0, left_denominator = 1;   // 0/1
    int right_numerator = 1, right_denominator = 0;  // 1/0 (∞)

    while (true) {
        int current_numerator = left_numerator + right_numerator;
        int current_denominator = left_denominator + right_denominator;

        if (current_numerator * b < current_denominator * a) {
            path += 'R';
            left_numerator = current_numerator;
            left_denominator = current_denominator;
        }
        else if (current_numerator * b > current_denominator * a) {
            path += 'L';
            right_numerator = current_numerator;
            right_denominator = current_denominator;
        }
        else {
            return "0"; // дробь найдена, но путь не указан
        }
    }
}

int main() {
    int a, b;
    cin >> a >> b;

    if (b == 0 || a < 1 || a >= 10000000 || b < 1 || b >= 10000000) {
        cout << "0" << endl;  // Невозможная дробь
    }
    else {
        string path = findPath(a, b);
        cout << path << endl;
    }

    return 0;
}
