﻿#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

struct Edge {
    int to;
    int length;
};

vector<vector<Edge>> graph;
vector<int> h;
vector<int> p;

bool canReach(int start, int end, int height) {
    queue<int> q;
    vector<bool> visited(graph.size(), false);
    q.push(start);
    visited[start] = true;

    while (!q.empty()) {
        int node = q.front();
        q.pop();

        if (node == end) return true;

        for (const auto& edge : graph[node]) {
            if (!visited[edge.to] && h[edge.to] >= height) {
                visited[edge.to] = true;
                q.push(edge.to);
            }
        }
    }
    return false;
}

int main() {
    int n, m, k;
    cin >> n >> m >> k;

    graph.resize(n + 1);
    h.resize(n + 1);
    p.resize(k + 1);

    for (int i = 1; i <= m; ++i) {
        int a, b, l;
        cin >> a >> b >> l;
        graph[a].push_back({ b, l });
        graph[b].push_back({ a, l });
    }

    for (int i = 1; i <= k; ++i) {
        cin >> p[i] >> h[i];
    }

    vector<int> guarded;
    for (int i = 1; i <= k; ++i) {
        bool can_guard = false;
        for (int j = 1; j <= n; ++j) {
            if (canReach(p[i], j, h[i])) {
                can_guard = true;
                break;
            }
        }
        if (can_guard) {
            guarded.push_back(p[i]);
        }
    }

    sort(guarded.begin(), guarded.end());
    cout << guarded.size() << endl;
    for (int g : guarded) {
        cout << g << " ";
    }
    cout << endl;

    return 0;
}
