from collections import deque


def can_reach(start, end, height, graph, h):
    queue = deque([start])
    visited = {start}

    while queue:
        node = queue.popleft()

        if node == end:
            return True

        for neighbor in graph[node]:
            if neighbor not in visited and h[neighbor] >= height:
                visited.add(neighbor)
                queue.append(neighbor)

    return False


def main():
    n, m, k = map(int, input().split())

    graph = {i: [] for i in range(1, n + 1)}
    for _ in range(m):
        a, b = map(int, input().split())
        graph[a].append(b)
        graph[b].append(a)

    h = {}
    p = []
    for _ in range(k):
        pi, hi = map(int, input().split())
        p.append(pi)
        h[pi] = hi

    protected = []
    for guard in p:
        can_guard = False
        for warehouse in range(1, n + 1):
            if can_reach(guard, warehouse, h[guard], graph, h):
                can_guard = True
                break
        if can_guard:
            protected.append(guard)

    protected.sort()

    print(len(protected))
    if protected:
        print(' '.join(map(str, protected)))


if __name__ == "__main__":
    main()
