from collections import deque


def bfs(start, height, graph, h):
    queue = deque([start])
    visited = {start}

    while queue:
        node = queue.popleft()

        for neighbor in graph[node]:
            if neighbor not in visited and h[neighbor] >= height:
                visited.add(neighbor)
                queue.append(neighbor)

    return visited


def main():
    n, m, k = map(int, input().split())

    graph = {i: [] for i in range(1, n + 1)}
    for _ in range(m):
        a, b = map(int, input().split())
        graph[a].append(b)
        graph[b].append(a)

    h = {}
    guards = []
    for _ in range(k):
        p_i, h_i = map(int, input().split())
        guards.append((p_i, h_i))
        h[p_i] = h_i

    protected = set()

    for guard in guards:
        p_i, h_i = guard
        reachable_warehouses = bfs(p_i, h_i, graph, h)
        protected.update(reachable_warehouses)

    protected = sorted([g for g in guards if g[0] in protected])

    print(len(protected))
    if protected:
        print(' '.join(str(g[0]) for g in protected))


if __name__ == "__main__":
    main()
