﻿#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <limits>

using namespace std;

struct Point {
    double x, y;
};

double distance(const Point& a, const Point& b) {
    return sqrt(pow(a.x - b.x, 2) + pow(a.y - b.y, 2));
}

double totalDistance(const vector<Point>& points, const vector<int>& order) {
    double total = 0.0;
    for (size_t i = 0; i < order.size() - 1; ++i) {
        total += distance(points[order[i]], points[order[i + 1]]);
    }
    return total;
}

int main() {
    int n;
    cin >> n;

    vector<Point> points(n);
    for (int i = 0; i < n; ++i) {
        cin >> points[i].x >> points[i].y;
    }

    vector<int> order(n);
    for (int i = 0; i < n; ++i) {
        order[i] = i;
    }

    double minDistance = numeric_limits<double>::max();

    do {
        double dist = totalDistance(points, order);
        minDistance = min(minDistance, dist);
    } while (next_permutation(order.begin(), order.end()));

    cout.precision(10);
    cout << fixed << minDistance << endl;

    return 0;
}
